package rocks.zipcode.quiz5.collections;

import rocks.zipcode.quiz5.objectorientation.Spice;
import rocks.zipcode.quiz5.objectorientation.account.BankAccount;

import java.util.*;

/**
 * @author leon on 27/12/2018.
 */
public class Food
{
    private Integer spiceAmount = 0;
    ArrayList<Spice> food = new ArrayList<Spice>();
    public List<Spice> getAllSpices()
    {
        return food;
    }

    public <SpiceType extends Class<? extends Spice>> Map<SpiceType, Integer> getSpiceCount()
    {
        LinkedHashMap<SpiceType, Integer> spiceCount = new LinkedHashMap<>();
        for (Spice s : food) {
            spiceCount.put((SpiceType) s.getClass(), s.getSpiciness());
        }
        for (Spice s : food) {
            s.setSpiciness(0);
        }
        return spiceCount;

    }

    public void applySpice(Spice spice)
    {
        if(!food.contains(spice)){
            food.add(spice);
        }
        spice.setSpiciness(spice.getSpiciness()+1);
    }
    }

