package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        int len=string.length();
        int c=len/2;
        char ch[]=string.toCharArray();
        return ch[c];
    }


    public static String capitalizeMiddleCharacter(String str)
    {
        StringBuilder sb = new StringBuilder(str);
        int len=str.length()/2;
        sb.setCharAt(len,Character.toUpperCase(str.charAt(len)));
        return sb.toString();

    }

    public static String lowerCaseMiddleCharacter(String str)
    {
        StringBuilder sb = new StringBuilder(str);
        int len=str.length()/2;
        sb.setCharAt(len,Character.toLowerCase(str.charAt(len)));
        return sb.toString();
    }

    public static Boolean isIsogram(String str)
    {
        String[] ary = str.split("");
        Set<String> mySet = new HashSet<String>(Arrays.asList(ary));

        if(str.length() == mySet.size()){
            return true;
        }else{
            return false;
        }
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        return (str.matches(".*(.)\\1.*"));
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        char[] ch = str.toCharArray();
        int length = 0;
        for(int i = 0; i<ch.length ; i++)
        {
            if(length ==0 || ch[i] != ch[length - 1])
                ch[length++] = ch[i];
            else
                length--;
        }
        return new String(ch,0,length);
    }

    public static String invertCasing(String str) {
        char[] chars = str.toCharArray();
        for (int i = 0; i < chars.length; i++)
        {
            char c = chars[i];
            if (Character.isUpperCase(c))
            {
                chars[i] = Character.toLowerCase(c);
            }
            else if (Character.isLowerCase(c))
            {
                chars[i] = Character.toUpperCase(c);
            }
        }
        return new String(chars);
    }
}